using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace AccellaNetApplication.Libraries.ControlsLibrary {
	/// <summary>
	/// Summary description for SystekToolbar.
	/// </summary>
	public class SystekToolbar : System.Windows.Forms.UserControl {
		public class ToolbarClickEventArgs {
			public ButtonTypes Button;
		}

		public ToolBar GetToolbar() { return toolbar; }

        public enum ButtonTypes { BSave = 0, BNew, BDelete, BPLS, BPreview, BBatteri1, BBatteri2, BRefresh, BKortProg, BCont, BPrint, BQuestion, BDown, BUp, BGreen, BRed, BExpand, BCollapse, BArrowLeft, BArrowRight, BAutoRefresh, BReset, BHelp, BExclamation};

		private System.Windows.Forms.ImageList bilder;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.ToolBar toolbar;

		private System.Windows.Forms.ToolBarButton ny;
		private System.Windows.Forms.ToolBarButton save;
		private System.Windows.Forms.ToolBarButton green;
		private System.Windows.Forms.ToolBarButton red;
		private System.Windows.Forms.ToolBarButton print;
		private System.Windows.Forms.ToolBarButton arrowDown;
		private System.Windows.Forms.ToolBarButton arrowUp;
		private System.Windows.Forms.ToolBarButton question;
		private System.Windows.Forms.ToolBarButton pls;
		private System.Windows.Forms.ToolBarButton preview;
		private System.Windows.Forms.ToolBarButton expand;
		private System.Windows.Forms.ToolBarButton collapse;
		private System.Windows.Forms.ToolBarButton arrowLeft;
		private System.Windows.Forms.ToolBarButton arrowRight;
		private System.Windows.Forms.ToolBarButton batteri1;
		private System.Windows.Forms.ToolBarButton batteri2;
		private System.Windows.Forms.ToolBarButton kortProg;
		private System.Windows.Forms.ToolBarButton refresh;
		private System.Windows.Forms.ToolBarButton autoRefresh;
		private System.Windows.Forms.ToolBarButton resetAlarm;
		private System.Windows.Forms.ToolBarButton help;
		private System.Windows.Forms.Timer autoActionTimer;
		private System.Windows.Forms.ToolBarButton cont;
        private ToolBarButton exclamation;
		private System.Windows.Forms.ToolBarButton delete;

		public delegate void ButtonClicked(object sender, ToolbarClickEventArgs e);
		public event ButtonClicked	ButtonEvent;

		public SystekToolbar() {
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();           
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing ) {
			if( disposing ) {
				if( components != null )
					components.Dispose();
			}
			autoActionTimer.Stop();
			autoActionTimer.Dispose();
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(SystekToolbar));
            this.toolbar = new System.Windows.Forms.ToolBar();
            this.save = new System.Windows.Forms.ToolBarButton();
            this.ny = new System.Windows.Forms.ToolBarButton();
            this.delete = new System.Windows.Forms.ToolBarButton();
            this.pls = new System.Windows.Forms.ToolBarButton();
            this.preview = new System.Windows.Forms.ToolBarButton();
            this.batteri1 = new System.Windows.Forms.ToolBarButton();
            this.batteri2 = new System.Windows.Forms.ToolBarButton();
            this.refresh = new System.Windows.Forms.ToolBarButton();
            this.kortProg = new System.Windows.Forms.ToolBarButton();
            this.cont = new System.Windows.Forms.ToolBarButton();
            this.print = new System.Windows.Forms.ToolBarButton();
            this.question = new System.Windows.Forms.ToolBarButton();
            this.arrowDown = new System.Windows.Forms.ToolBarButton();
            this.arrowUp = new System.Windows.Forms.ToolBarButton();
            this.green = new System.Windows.Forms.ToolBarButton();
            this.red = new System.Windows.Forms.ToolBarButton();
            this.expand = new System.Windows.Forms.ToolBarButton();
            this.collapse = new System.Windows.Forms.ToolBarButton();
            this.arrowLeft = new System.Windows.Forms.ToolBarButton();
            this.arrowRight = new System.Windows.Forms.ToolBarButton();
            this.autoRefresh = new System.Windows.Forms.ToolBarButton();
            this.resetAlarm = new System.Windows.Forms.ToolBarButton();
            this.help = new System.Windows.Forms.ToolBarButton();
            this.exclamation = new System.Windows.Forms.ToolBarButton();
            this.bilder = new System.Windows.Forms.ImageList(this.components);
            this.autoActionTimer = new System.Windows.Forms.Timer(this.components);
            this.SuspendLayout();
            // 
            // toolbar
            // 
            this.toolbar.Appearance = System.Windows.Forms.ToolBarAppearance.Flat;
            this.toolbar.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
            this.save,
            this.ny,
            this.delete,
            this.pls,
            this.preview,
            this.batteri1,
            this.batteri2,
            this.refresh,
            this.kortProg,
            this.cont,
            this.print,
            this.question,
            this.arrowDown,
            this.arrowUp,
            this.green,
            this.red,
            this.expand,
            this.collapse,
            this.arrowLeft,
            this.arrowRight,
            this.autoRefresh,
            this.resetAlarm,
            this.help,
            this.exclamation});
            this.toolbar.ButtonSize = new System.Drawing.Size(60, 30);
            this.toolbar.Divider = false;
            this.toolbar.Dock = System.Windows.Forms.DockStyle.Fill;
            this.toolbar.DropDownArrows = true;
            this.toolbar.ImageList = this.bilder;
            this.toolbar.Location = new System.Drawing.Point(0, 0);
            this.toolbar.Name = "toolbar";
            this.toolbar.ShowToolTips = true;
            this.toolbar.Size = new System.Drawing.Size(184, 34);
            this.toolbar.TabIndex = 0;
            this.toolbar.TextAlign = System.Windows.Forms.ToolBarTextAlign.Right;
            this.toolbar.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolbar_ButtonClick);
            this.toolbar.KeyUp += new System.Windows.Forms.KeyEventHandler(this.toolbar_KeyUp);
            // 
            // save
            // 
            this.save.ImageIndex = 43;
            this.save.Name = "save";
            this.save.Tag = "save";
            this.save.Text = "Lagre";
            this.save.ToolTipText = "Lagre all informasjon";
            this.save.Visible = false;
            // 
            // ny
            // 
            this.ny.ImageIndex = 30;
            this.ny.Name = "ny";
            this.ny.Tag = "ny";
            this.ny.Text = "Ny";
            this.ny.ToolTipText = "Lag ny rad";
            this.ny.Visible = false;
            // 
            // delete
            // 
            this.delete.ImageIndex = 55;
            this.delete.Name = "delete";
            this.delete.Tag = "delete";
            this.delete.Text = "Slett";
            this.delete.ToolTipText = "Slett valgt rad";
            this.delete.Visible = false;
            // 
            // pls
            // 
            this.pls.ImageIndex = 37;
            this.pls.Name = "pls";
            this.pls.Tag = "pls";
            this.pls.Text = "PLS";
            this.pls.ToolTipText = "Hjelp";
            this.pls.Visible = false;
            // 
            // preview
            // 
            this.preview.ImageIndex = 45;
            this.preview.Name = "preview";
            this.preview.Tag = "preview";
            this.preview.Text = "Forhndsvisning";
            this.preview.ToolTipText = "Forhndsvisning";
            this.preview.Visible = false;
            // 
            // batteri1
            // 
            this.batteri1.ImageIndex = 18;
            this.batteri1.Name = "batteri1";
            this.batteri1.Tag = "batteri1";
            this.batteri1.ToolTipText = "Hjelp";
            this.batteri1.Visible = false;
            // 
            // batteri2
            // 
            this.batteri2.ImageIndex = 46;
            this.batteri2.Name = "batteri2";
            this.batteri2.Tag = "batteri2";
            this.batteri2.Text = "PLS";
            this.batteri2.ToolTipText = "Hjelp";
            this.batteri2.Visible = false;
            // 
            // refresh
            // 
            this.refresh.ImageIndex = 40;
            this.refresh.Name = "refresh";
            this.refresh.Tag = "refresh";
            this.refresh.Text = "Oppdater";
            this.refresh.ToolTipText = "Oppdater all informasjon i bildet";
            this.refresh.Visible = false;
            // 
            // kortProg
            // 
            this.kortProg.ImageIndex = 20;
            this.kortProg.Name = "kortProg";
            this.kortProg.Tag = "kortprog";
            this.kortProg.ToolTipText = "Hjelp";
            this.kortProg.Visible = false;
            // 
            // cont
            // 
            this.cont.ImageIndex = 56;
            this.cont.Name = "cont";
            this.cont.Tag = "cont";
            this.cont.Text = "Les inn";
            this.cont.ToolTipText = "Hent fra fil";
            this.cont.Visible = false;
            // 
            // print
            // 
            this.print.ImageIndex = 38;
            this.print.Name = "print";
            this.print.Tag = "print";
            this.print.Text = "Utskrift";
            this.print.ToolTipText = "Skriv ut";
            this.print.Visible = false;
            // 
            // question
            // 
            this.question.ImageIndex = 39;
            this.question.Name = "question";
            this.question.Tag = "question";
            this.question.ToolTipText = "Hjelp";
            this.question.Visible = false;
            // 
            // arrowDown
            // 
            this.arrowDown.ImageIndex = 50;
            this.arrowDown.Name = "arrowDown";
            this.arrowDown.Tag = "arrowDown";
            this.arrowDown.ToolTipText = "Hjelp";
            this.arrowDown.Visible = false;
            // 
            // arrowUp
            // 
            this.arrowUp.ImageIndex = 49;
            this.arrowUp.Name = "arrowUp";
            this.arrowUp.Tag = "arrowUp";
            this.arrowUp.ToolTipText = "Hjelp";
            this.arrowUp.Visible = false;
            // 
            // green
            // 
            this.green.ImageIndex = 2;
            this.green.Name = "green";
            this.green.Tag = "green";
            this.green.ToolTipText = "Hjelp";
            this.green.Visible = false;
            // 
            // red
            // 
            this.red.ImageIndex = 54;
            this.red.Name = "red";
            this.red.Tag = "red";
            this.red.Text = "Excel";
            this.red.ToolTipText = "Hjelp";
            this.red.Visible = false;
            // 
            // expand
            // 
            this.expand.ImageIndex = 51;
            this.expand.Name = "expand";
            this.expand.Tag = "expand";
            this.expand.Text = "Utvid";
            this.expand.ToolTipText = "Se alle rader";
            this.expand.Visible = false;
            // 
            // collapse
            // 
            this.collapse.ImageIndex = 52;
            this.collapse.Name = "collapse";
            this.collapse.Tag = "collapse";
            this.collapse.Text = "Skjul";
            this.collapse.ToolTipText = "Se kun hovedrader";
            this.collapse.Visible = false;
            // 
            // arrowLeft
            // 
            this.arrowLeft.ImageIndex = 47;
            this.arrowLeft.Name = "arrowLeft";
            this.arrowLeft.Tag = "arrowLeft";
            this.arrowLeft.ToolTipText = "Hjelp";
            this.arrowLeft.Visible = false;
            // 
            // arrowRight
            // 
            this.arrowRight.ImageIndex = 48;
            this.arrowRight.Name = "arrowRight";
            this.arrowRight.Tag = "arrowRight";
            this.arrowRight.ToolTipText = "Hjelp";
            this.arrowRight.Visible = false;
            // 
            // autoRefresh
            // 
            this.autoRefresh.ImageIndex = 53;
            this.autoRefresh.Name = "autoRefresh";
            this.autoRefresh.Pushed = false;
            this.autoRefresh.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
            this.autoRefresh.Tag = "autoRefresh";
            this.autoRefresh.Text = "2";
            this.autoRefresh.ToolTipText = "Hjelp";
            this.autoRefresh.Visible = false;
            // 
            // resetAlarm
            // 
            this.resetAlarm.ImageIndex = 31;
            this.resetAlarm.Name = "resetAlarm";
            this.resetAlarm.Tag = "resetAlarm";
            this.resetAlarm.ToolTipText = "Hjelp";
            this.resetAlarm.Visible = false;
            // 
            // help
            // 
            this.help.ImageIndex = 33;
            this.help.Name = "help";
            this.help.Tag = "help";
            this.help.Text = "Hjelp";
            this.help.ToolTipText = "Hjelp";
            // 
            // exclamation
            // 
            this.exclamation.ImageIndex = 44;
            this.exclamation.Name = "exclamation";
            this.exclamation.Tag = "exclamation";
            this.exclamation.Visible = false;
            // 
            // bilder
            // 
            this.bilder.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("bilder.ImageStream")));
            this.bilder.TransparentColor = System.Drawing.Color.Transparent;
            this.bilder.Images.SetKeyName(0, "");
            this.bilder.Images.SetKeyName(1, "");
            this.bilder.Images.SetKeyName(2, "");
            this.bilder.Images.SetKeyName(3, "");
            this.bilder.Images.SetKeyName(4, "");
            this.bilder.Images.SetKeyName(5, "");
            this.bilder.Images.SetKeyName(6, "");
            this.bilder.Images.SetKeyName(7, "");
            this.bilder.Images.SetKeyName(8, "");
            this.bilder.Images.SetKeyName(9, "");
            this.bilder.Images.SetKeyName(10, "");
            this.bilder.Images.SetKeyName(11, "");
            this.bilder.Images.SetKeyName(12, "");
            this.bilder.Images.SetKeyName(13, "");
            this.bilder.Images.SetKeyName(14, "");
            this.bilder.Images.SetKeyName(15, "");
            this.bilder.Images.SetKeyName(16, "");
            this.bilder.Images.SetKeyName(17, "");
            this.bilder.Images.SetKeyName(18, "");
            this.bilder.Images.SetKeyName(19, "");
            this.bilder.Images.SetKeyName(20, "");
            this.bilder.Images.SetKeyName(21, "");
            this.bilder.Images.SetKeyName(22, "");
            this.bilder.Images.SetKeyName(23, "");
            this.bilder.Images.SetKeyName(24, "");
            this.bilder.Images.SetKeyName(25, "");
            this.bilder.Images.SetKeyName(26, "");
            this.bilder.Images.SetKeyName(27, "exclamation.JPG");
            this.bilder.Images.SetKeyName(28, "Erase.gif");
            this.bilder.Images.SetKeyName(29, "delete.gif");
            this.bilder.Images.SetKeyName(30, "new document.gif");
            this.bilder.Images.SetKeyName(31, "mute.gif");
            this.bilder.Images.SetKeyName(32, "volume.gif");
            this.bilder.Images.SetKeyName(33, "hint.gif");
            this.bilder.Images.SetKeyName(34, "Help book 3d.gif");
            this.bilder.Images.SetKeyName(35, "Help book.gif");
            this.bilder.Images.SetKeyName(36, "Help.gif");
            this.bilder.Images.SetKeyName(37, "Download.gif");
            this.bilder.Images.SetKeyName(38, "print.gif");
            this.bilder.Images.SetKeyName(39, "question.gif");
            this.bilder.Images.SetKeyName(40, "refresh.gif");
            this.bilder.Images.SetKeyName(41, "Redo.gif");
            this.bilder.Images.SetKeyName(42, "schedule.gif");
            this.bilder.Images.SetKeyName(43, "Save.gif");
            this.bilder.Images.SetKeyName(44, "problem.gif");
            this.bilder.Images.SetKeyName(45, "Text preview.gif");
            this.bilder.Images.SetKeyName(46, "upload.gif");
            this.bilder.Images.SetKeyName(47, "Back.gif");
            this.bilder.Images.SetKeyName(48, "Forward.gif");
            this.bilder.Images.SetKeyName(49, "Up.gif");
            this.bilder.Images.SetKeyName(50, "Down.gif");
            this.bilder.Images.SetKeyName(51, "Expand.gif");
            this.bilder.Images.SetKeyName(52, "Top.gif");
            this.bilder.Images.SetKeyName(53, "History.gif");
            this.bilder.Images.SetKeyName(54, "Table.gif");
            this.bilder.Images.SetKeyName(55, "Trash.gif");
            this.bilder.Images.SetKeyName(56, "List.gif");
            // 
            // autoActionTimer
            // 
            this.autoActionTimer.Enabled = true;
            this.autoActionTimer.Interval = 1000;
            this.autoActionTimer.Tick += new System.EventHandler(this.autoActionTimer_Tick);
            // 
            // SystekToolbar
            // 
            this.Controls.Add(this.toolbar);
            this.Name = "SystekToolbar";
            this.Size = new System.Drawing.Size(184, 32);
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		private void toolbar_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e) {
			toolbar.Focus();
			if (ButtonEvent != null) {
				ToolbarClickEventArgs ee = new ToolbarClickEventArgs();
				ee.Button = (ButtonTypes)toolbar.Buttons.IndexOf(e.Button);
				ButtonEvent(sender,ee);
			}

			if ( e.Button == ny && OnNew != null ) {
				OnNew(e.Button, e);
			} else if ( e.Button == save && OnSave != null ) {
				OnSave(e.Button, e);
			} else if ( e.Button == green && OnGreen != null ) {
				OnGreen(e.Button, e);
			} else if ( e.Button == red && OnRed != null ) {
				OnRed(e.Button, e);
			} else if ( e.Button == print && OnPrint != null ) {
				OnPrint(e.Button, e);
			} else if ( e.Button == arrowDown && OnArrowDown != null ) {
				OnArrowDown(e.Button, e);
			} else if ( e.Button == arrowUp && OnArrowUp != null ) {
				OnArrowUp(e.Button, e);
			} else if ( e.Button == question && OnQuestion != null ) {
				OnQuestion(e.Button, e);
			} else if ( e.Button == pls && OnPlc != null ) {
				OnPlc(e.Button, e);
			} else if ( e.Button == cont && OnCont != null ) {
				OnCont(e.Button, e);
			} else if ( e.Button == preview && OnPreview != null ) {
				OnPreview(e.Button, e);
			} else if ( e.Button == expand && OnExpand != null ) {
				OnExpand(e.Button, e);
			} else if ( e.Button == collapse && OnCollapse != null ) {
				OnCollapse(e.Button, e);
			} else if ( e.Button == arrowLeft && OnArrowLeft != null ) {
				OnArrowLeft(e.Button, e);
			} else if ( e.Button == arrowRight && OnArrowRight != null ) {
				OnArrowRight(e.Button, e);
			} else if ( e.Button == help && OnHelp != null ) {
				OnHelp(e.Button, e);
			} else if ( e.Button == batteri1 && OnBatteri1 != null ) {
				OnBatteri1(e.Button, e);
			} else if ( e.Button == batteri2 && OnBatteri2 != null ) {
				OnBatteri2(e.Button, e);
			} else if ( e.Button == kortProg && OnCardProgram != null ) {
				OnCardProgram(e.Button, e);
			} else if ( e.Button == refresh && OnRefresh != null ) {
				OnRefresh(e.Button, e);
			} else if ( e.Button == delete && OnDelete != null ) {
				OnDelete(e.Button, e);
            }
            else if (e.Button == exclamation && OnExclamation != null)
            {
                OnExclamation(e.Button, e);
            } else if (e.Button == autoRefresh) {
				if ( autoRefresh.Pushed ) autoActionTimer.Start();
				else autoActionTimer.Stop();
			} else if ( e.Button == resetAlarm && OnResetAlarm != null) {
				OnResetAlarm(e.Button, e);
			}
		}

		public ToolBar.ToolBarButtonCollection Buttons {
			get {
				return toolbar.Buttons;
			}
		}

		public event EventHandler OnCont;
		public event EventHandler OnNew;
		public event EventHandler OnSave;
		public event EventHandler OnGreen;
		public event EventHandler OnRed;
        public new event EventHandler OnPrint;
		public event EventHandler OnArrowDown;
		public event EventHandler OnArrowUp;
		public event EventHandler OnQuestion;
		public event EventHandler OnPlc;
		public event EventHandler OnPreview;
		public event EventHandler OnExpand;
		public event EventHandler OnCollapse;
		public event EventHandler OnArrowLeft;
		public event EventHandler OnArrowRight;
		public event EventHandler OnHelp;
		public event EventHandler OnBatteri1;
		public event EventHandler OnBatteri2;
		public event EventHandler OnCardProgram;
		public event EventHandler OnRefresh;
		public event EventHandler OnDelete;
		public event EventHandler OnResetAlarm;
        public event EventHandler OnExclamation;

		[DefaultValue(true)]
		public bool BtnHelp {
			get { return help.Visible; }
			set { help.Visible = value; }
		}
		[DefaultValue(false)]
		public bool BtnKortProg {
			get { return kortProg.Visible; }
			set { kortProg.Visible = value; }
		}
		[DefaultValue(false)]
		public bool BtnBatteri1 {
			get { return batteri1.Visible; }
			set { batteri1.Visible = value; }
		}
		[DefaultValue(false)]
		public bool BtnBatteri2 {
			get { return batteri2.Visible; }
			set { batteri2.Visible = value; }
		}
		[DefaultValue(false)]
		public bool BtnExpand {
			get { return expand.Visible; }
			set { expand.Visible = value; }
		}
		[DefaultValue(false)]
		public bool BtnCollapse {
			get { return collapse.Visible; }
			set { collapse.Visible = value; }
		}
		[DefaultValue(false)]
		public bool BtnPreview {
			get { return preview.Visible; }
			set { preview.Visible = value; }
		}
		[DefaultValue(false)]
		public bool BtnPls {
			get { return pls.Visible; }
			set { pls.Visible = value; }
		}
		[DefaultValue(false)]
		public bool BtnSave {
			get { return save.Visible; }
			set { save.Visible = value; }
		}
		[DefaultValue(false)]
		public bool BtnNew {
			get { return ny.Visible; }
			set { ny.Visible = value; }
		}
		[DefaultValue(false)]
		public bool BtnRefresh {
			get { return refresh.Visible; }
			set { refresh.Visible = value; }
		}
		[DefaultValue(false)]
		public bool BtnDelete {
			get { return delete.Visible; }
			set { delete.Visible = value; }
		}
        [DefaultValue(false)]
        public bool BtnExclamation
        {
            get { return exclamation.Visible; }
            set { exclamation.Visible = value; }
        }
        [DefaultValue(false)]
		public bool BtnArrowLeft {
			get { return arrowLeft.Visible; }
			set { arrowLeft.Visible = value; }
		}
		[DefaultValue(false)]
		public bool BtnArrowRight {
			get { return arrowRight.Visible; }
			set { arrowRight.Visible = value; }
		}
		[DefaultValue(false)]
		public bool BtnArrowUp {
			get { return arrowUp.Visible; }
			set { arrowUp.Visible = value; }
		}
		[DefaultValue(false)]
		public bool BtnArrowDown {
			get { return arrowDown.Visible; }
			set { arrowDown.Visible = value; }
		}
		[DefaultValue(false)]
		public bool BtnCont {
			get { return cont.Visible; }
			set { cont.Visible = value; }
		}
		[DefaultValue(false)]
		public bool BtnPrint {
			get { return print.Visible; }
			set { print.Visible = value; }
		}
		[DefaultValue(false)]
		public bool BtnRed {
			get { return red.Visible; }
			set { red.Visible = value; }
		}
		[DefaultValue(false)]
		public bool BtnGreen {
			get { return green.Visible; }
			set { green.Visible = value; }
		}
		[DefaultValue(false)]
		public bool BtnQuestion {
			get { return question.Visible; }
			set { question.Visible = value; }
		}
		[DefaultValue(false)]
		public bool BtnResetAlarm {
			get { return resetAlarm.Visible; }
			set { resetAlarm.Visible = value; }
		}
		[DefaultValue(false)]
		public bool BtnAutoRefresh {
			get { return autoRefresh.Visible; }
			set {
				autoRefresh.Visible = value;
				if ( value ) autoActionTimer.Start();
				else autoActionTimer.Stop();
			}
		}
		private int refreshIntervals = 2;
		private int refreshCountdown = 2;

		public void toolbar_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e) {
			if ( e.KeyCode == Keys.F5 && BtnRefresh && OnRefresh != null ) {
				e.Handled = true;
				OnRefresh(refresh, new EventArgs());
			} else if ( e.Control && e.KeyCode == Keys.P && OnPrint != null ) {
				e.Handled = true;
				OnPrint(print, new EventArgs());
			}
		}

		private void autoActionTimer_Tick(object sender, System.EventArgs e) {
			if ( !BtnAutoRefresh || !autoRefresh.Pushed  ) {
				autoActionTimer.Stop();
				return;
			}
			if ( Parent == null || Parent.Visible == false ) {
				autoActionTimer.Stop();
				return;
			}
			
			refreshCountdown--;
			autoRefresh.Text = refreshCountdown.ToString();
			if ( refreshCountdown != 0 ) return;


			refreshCountdown = refreshIntervals;
			if ( OnRefresh != null ) OnRefresh(refresh, new EventArgs());		
		}

	
		[DefaultValue(10)]
		public int RefreshInterval {
			get { return refreshIntervals; }
			set { refreshCountdown = refreshIntervals = value; }
		}



		[DefaultValue(false)]
		public bool EnabledResetAlarm {
			get { return resetAlarm.Enabled; }
			set { resetAlarm.Enabled = value; }
		}
		[DefaultValue(true)]
		public bool EnabledHelp {
			get { return help.Enabled; }
			set { help.Enabled = value; }
		}
		[DefaultValue(true)]
		public bool EnabledKortProg {
			get { return kortProg.Enabled; }
			set { kortProg.Enabled = value; }
		}
		[DefaultValue(true)]
		public bool EnabledBatteri1 {
			get { return batteri1.Enabled; }
			set { batteri1.Enabled = value; }
		}
		[DefaultValue(true)]
		public bool EnabledBatteri2 {
			get { return batteri2.Enabled; }
			set { batteri2.Enabled = value; }
		}
		[DefaultValue(true)]
		public bool EnabledExpand {
			get { return expand.Enabled; }
			set { expand.Enabled = value; }
		}
		[DefaultValue(true)]
		public bool EnabledCollapse {
			get { return collapse.Enabled; }
			set { collapse.Enabled = value; }
		}
		[DefaultValue(true)]
		public bool EnabledPreview {
			get { return preview.Enabled; }
			set { preview.Enabled = value; }
		}
		[DefaultValue(true)]
		public bool EnabledPls {
			get { return pls.Enabled; }
			set { pls.Enabled = value; }
		}
		[DefaultValue(true)]
		public bool EnabledSave {
			get { return save.Enabled; }
			set { save.Enabled = value; }
		}
		[DefaultValue(true)]
		public bool EnabledNew {
			get { return ny.Enabled; }
			set { ny.Enabled = value; }
		}
		[DefaultValue(true)]
		public bool EnabledDelete {
			get { return delete.Enabled; }
			set { delete.Enabled = value; }
		}
        [DefaultValue(true)]
        public bool EnabledExclamation
        {
            get { return exclamation.Enabled; }
            set { exclamation.Enabled = value; }
        }
        [DefaultValue(true)]
		public bool EnabledArrowLeft {
			get { return arrowLeft.Enabled; }
			set { arrowLeft.Enabled = value; }
		}
		[DefaultValue(true)]
		public bool EnabledArrowRight {
			get { return arrowRight.Enabled; }
			set { arrowRight.Enabled = value; }
		}
		[DefaultValue(true)]
		public bool EnabledArrowUp {
			get { return arrowUp.Enabled; }
			set { arrowUp.Enabled = value; }
		}
		[DefaultValue(true)]
		public bool EnabledArrowDown {
			get { return arrowDown.Enabled; }
			set { arrowDown.Enabled = value; }
		}
		[DefaultValue(true)]
		public bool EnabledCont {
			get { return cont.Enabled; }
			set { cont.Enabled = value; }
		}
		[DefaultValue(true)]
		public bool EnabledPrint {
			get { return print.Enabled; }
			set { print.Enabled = value; }
		}
		[DefaultValue(true)]
		public bool EnabledRed {
			get { return red.Enabled; }
			set { red.Enabled = value; }
		}
		[DefaultValue(true)]
		public bool EnabledGreen {
			get { return green.Enabled; }
			set { green.Enabled = value; }
		}
		[DefaultValue(true)]
		public bool EnabledQuestion {
			get { return question.Enabled; }
			set { question.Enabled = value; }
		}	

		public ToolBar ToolBar {
			get { return this.toolbar; }
		}
	}
}